/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.common.SCommon
 *  fire.pb.main.ConfigManager
 *  fire.pb.npc.NpcManager
 *  fire.pb.shop.Goods
 *  fire.pb.shop.Module
 *  fire.pb.shop.SGoods
 *  fire.pb.shop.SNpcSale
 *  fire.pb.shop.srv.Shop
 *  mkdb.Procedure
 *  xbean.GoodsBusiness
 *  xbean.NpcSaleBusiness
 *  xbean.Pod
 *  xtable.Npcsalebusinesstab
 */
package fire.pb.shop.srv.floating;

import fire.pb.common.SCommon;
import fire.pb.main.ConfigManager;
import fire.pb.npc.NpcManager;
import fire.pb.shop.Goods;
import fire.pb.shop.Module;
import fire.pb.shop.SGoods;
import fire.pb.shop.SNpcSale;
import fire.pb.shop.srv.Shop;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import mkdb.Procedure;
import xbean.GoodsBusiness;
import xbean.NpcSaleBusiness;
import xbean.Pod;
import xtable.Npcsalebusinesstab;

public class FloatingOneManager {
    public Map<Integer, SCommon> commonMap = ConfigManager.getInstance().getConf(SCommon.class);
    public Map<Integer, SGoods> goodsMap = Module.sGoodsMap;

    private FloatingOneManager() {
    }

    public static FloatingOneManager getInstance() {
        return FlotingManagerHolder.instance;
    }

    public ArrayList<Goods> getGoodsAndPrice(long shopId) {
        NpcSaleBusiness npcSaleBusiness = Npcsalebusinesstab.get((Long)shopId);
        if (npcSaleBusiness == null) {
            return null;
        }
        Map goodsBusinessMap = npcSaleBusiness.getGoodsmap();
        if (goodsBusinessMap.isEmpty()) {
            return null;
        }
        ArrayList<Goods> goodsList = new ArrayList<Goods>();
        for (Map.Entry entry : goodsBusinessMap.entrySet()) {
            Goods goods;
            int goodsid = (Integer)entry.getKey();
            GoodsBusiness goodsBusiness = (GoodsBusiness)entry.getValue();
            int priorPeriodPrice = goodsBusiness.getPriorperiodprice();
            int price = goodsBusiness.getPrice();
            if (price <= 0) {
                Shop.LOG.error((Object)("从浮动商店中获取商品价格异常：shopId=" + shopId + ", goodsid=" + goodsid + "价格异常,价格为=" + price));
                goods = this.goodsMap.get(goodsid);
                price = (Integer)goods.getPrices().get(0);
            }
            goods = new Goods();
            goods.goodsid = goodsid;
            goods.price = price;
            goods.priorperiodprice = priorPeriodPrice;
            goodsList.add(goods);
        }
        return goodsList;
    }

    public void buyGoodsRecord(long shopId, int goodsid, long num) {
        if (num == 0L) {
            return;
        }
        NpcSaleBusiness npcSaleBusiness = Npcsalebusinesstab.get((Long)shopId);
        if (npcSaleBusiness == null) {
            return;
        }
        GoodsBusiness goodsBusiness = (GoodsBusiness)npcSaleBusiness.getGoodsmap().get(goodsid);
        if (goodsBusiness == null) {
            return;
        }
        long buyNum = goodsBusiness.getBuynum();
        goodsBusiness.setBuynum(buyNum + num);
        short isActivate = npcSaleBusiness.getIsactive();
        if (isActivate == 0) {
            npcSaleBusiness.setIsactive((short)1);
        }
    }

    public void saleGoodsRecord(long shopId, int goodsid, long num) {
        if (num == 0L) {
            return;
        }
        NpcSaleBusiness npcSaleBusiness = Npcsalebusinesstab.get((Long)shopId);
        if (npcSaleBusiness == null) {
            return;
        }
        GoodsBusiness goodsBusiness = (GoodsBusiness)npcSaleBusiness.getGoodsmap().get(goodsid);
        if (goodsBusiness == null) {
            return;
        }
        long saleNum = goodsBusiness.getSalenum();
        goodsBusiness.setSalenum(saleNum + num);
    }

    public int getCurrPrice(long shopId, int goodsid) {
        NpcSaleBusiness npcSaleBusiness = Npcsalebusinesstab.get((Long)shopId);
        if (npcSaleBusiness == null) {
            return -1;
        }
        GoodsBusiness goodsBusiness = (GoodsBusiness)npcSaleBusiness.getGoodsmap().get(goodsid);
        int currPrice = goodsBusiness.getPrice();
        if (currPrice > 0) {
            return currPrice;
        }
        Shop.LOG.error((Object)("从浮动商店中获取商品价格异常：shopId=" + shopId + ", goodsid=" + goodsid + "价格异常,价格为=" + currPrice));
        return -1;
    }

    private int getX() {
        SCommon conf;
        if (this.commonMap != null && (conf = this.commonMap.get(140)) != null) {
            return Integer.parseInt(conf.getValue());
        }
        Shop.LOG.error((Object)"获取统计周期常量x错误");
        return -1;
    }

    private int getY() {
        SCommon conf;
        if (this.commonMap != null && (conf = this.commonMap.get(141)) != null) {
            return Integer.parseInt(conf.getValue());
        }
        Shop.LOG.error((Object)"获取统计系数常量y错误");
        return -1;
    }

    public void removeStatisticsShopData(List<Long> shopIds) {
        for (Long shopId : shopIds) {
            NpcSaleBusiness npcSaleBusiness = Npcsalebusinesstab.get((Long)shopId);
            if (npcSaleBusiness == null) continue;
            Npcsalebusinesstab.remove((Long)shopId);
        }
    }

    public void initStatisticsShopData(Long shopId) {
        NpcSaleBusiness npcSaleBusiness = Npcsalebusinesstab.get((Long)shopId);
        SNpcSale npcSale = NpcManager.getInstance().getNpcSale(shopId.intValue());
        ArrayList goodsIds = npcSale.getGoodsids();
        if (npcSaleBusiness != null) {
            Map initGoodsMap = npcSaleBusiness.getGoodsmap();
            for (Integer goodsId : goodsIds) {
                if (initGoodsMap.containsKey(goodsId)) continue;
                this.initMkdbGoodsData(goodsId, npcSaleBusiness);
                Shop.LOG.info((Object)("已初始化过的npc商店商品, 商店id=" + shopId + ", 新增并初始化商品=" + goodsId));
            }
            return;
        }
        npcSaleBusiness = Pod.newNpcSaleBusiness();
        Npcsalebusinesstab.insert((Long)shopId, (NpcSaleBusiness)npcSaleBusiness);
        for (Integer goodsId : goodsIds) {
            this.initMkdbGoodsData(goodsId, npcSaleBusiness);
        }
    }

    protected void initMkdbGoodsData(Integer goodsId, NpcSaleBusiness npcSaleBusiness) {
        SGoods goods = this.goodsMap.get(goodsId);
        int price = (Integer)goods.getPrices().get(0);
        Map initGoodsMap = npcSaleBusiness.getGoodsmap();
        GoodsBusiness goodsBusiness = Pod.newGoodsBusiness();
        goodsBusiness.setPriorperiodprice(price);
        goodsBusiness.setPrice(price);
        initGoodsMap.put(goodsId, goodsBusiness);
    }

    public class StatisticsOne
    extends Procedure {
        private List<Long> shopIds;
        private long currTime;

        public StatisticsOne(List<Long> shopIds, long currTime) {
            this.shopIds = shopIds;
            this.currTime = currTime;
        }

        protected boolean process() throws Exception {
            for (Long shopId : this.shopIds) {
                NpcSaleBusiness npcSaleBusiness = Npcsalebusinesstab.get((Long)shopId);
                if (npcSaleBusiness == null) {
                    FloatingOneManager.this.initStatisticsShopData(shopId);
                    continue;
                }
                this.statisticsShopData(npcSaleBusiness, shopId);
            }
            return true;
        }

        private boolean statisticsShopData(NpcSaleBusiness npcSaleBusiness, Long shopId) {
            SNpcSale npcSale = NpcManager.getInstance().getNpcSale(shopId.intValue());
            long intervalTime = npcSale.floatingtime * 1000;
            long time = npcSaleBusiness.getTime();
            int isActivate = npcSale.floating;
            if (this.currTime - time < intervalTime || isActivate == 0) {
                return false;
            }
            npcSaleBusiness.setTime(this.currTime);
            Map goodsBusinessMap = npcSaleBusiness.getGoodsmap();
            for (Map.Entry entry : goodsBusinessMap.entrySet()) {
                int goodsid = (Integer)entry.getKey();
                GoodsBusiness goodsBusiness = (GoodsBusiness)entry.getValue();
                int count = goodsBusiness.getCount();
                long buyNum = goodsBusiness.getBuynum();
                long saleNum = goodsBusiness.getSalenum();
                long result = buyNum - saleNum;
                long lastNum = goodsBusiness.getLastnum();
                int currPrice = goodsBusiness.getPrice();
                int newPrice = 0;
                boolean isChange = false;
                SGoods goods = FloatingOneManager.getInstance().goodsMap.get(goodsid);
                if (goods == null) {
                    StringBuilder sbd = new StringBuilder();
                    sbd.append("价格浮动统计, 此道具已被策划删除所以不参与价格浮动统计.商品id=").append(goodsid);
                    Shop.LOG.error((Object)sbd.toString());
                    continue;
                }
                int price = (Integer)goods.getPrices().get(0);
                int floatingRisePrice = (int)goods.getFloatingRisePrice();
                int floatingDepreciatePrice = (int)goods.getFloatingDepreciatePrice();
                double floatingPriceMax = goods.getFloatingmax();
                double floatingPriceMin = goods.getFloatingmin();
                if (result > 0L) {
                    int b;
                    double a;
                    if (result > lastNum) {
                        a = Math.ceil((double)price * floatingPriceMax);
                        newPrice = (int)Math.min(a, (double)(b = currPrice + floatingRisePrice));
                        if (newPrice <= 0) {
                            Shop.LOG.error((Object)("价格浮动one计算时,商品价格向下溢出,出现价格小于或等于0的新价格,shopId=" + shopId + "商品id=" + goodsid));
                            continue;
                        }
                        isChange = true;
                    }
                    if (result < lastNum) {
                        a = Math.ceil((double)price * floatingPriceMin);
                        newPrice = (int)Math.max(a, (double)(b = currPrice - floatingDepreciatePrice));
                        if (newPrice <= 0) {
                            Shop.LOG.error((Object)("价格浮动one计算时,商品价格向下溢出,出现价格小于或等于0的新价格,shopId=" + shopId + "商品id=" + goodsid));
                            continue;
                        }
                        isChange = true;
                    }
                    goodsBusiness.setCount(0);
                }
                if (result <= 0L) {
                    int x = FloatingOneManager.this.getX();
                    if (x == -1) {
                        return false;
                    }
                    goodsBusiness.setCount(count + 1);
                    count = goodsBusiness.getCount();
                    if (count >= x) {
                        int b;
                        goodsBusiness.setCount(0);
                        int y = FloatingOneManager.this.getY();
                        if (y == -1) {
                            return false;
                        }
                        double a = Math.ceil((double)price * floatingPriceMin);
                        newPrice = (int)Math.max(a, (double)(b = currPrice - floatingDepreciatePrice * y));
                        if (newPrice <= 0) {
                            Shop.LOG.error((Object)("价格浮动one计算时,商品价格向下溢出,出现价格小于或等于0的新价格,shopId=" + shopId + "商品id=" + goodsid));
                            continue;
                        }
                        isChange = true;
                    }
                }
                if (isChange) {
                    goodsBusiness.setPriorperiodprice(currPrice);
                    goodsBusiness.setPrice(newPrice);
                } else {
                    goodsBusiness.setPriorperiodprice(currPrice);
                    goodsBusiness.setPrice(currPrice);
                }
                goodsBusiness.setBuynum(0L);
                goodsBusiness.setSalenum(0L);
                goodsBusiness.setLastnum(result);
            }
            return true;
        }
    }

    public static class FlotingManagerHolder {
        static FloatingOneManager instance = new FloatingOneManager();
    }
}

